package com.example.application.utils;

import com.example.application.data.entity.Player;
import com.vaadin.flow.data.renderer.TemplateRenderer;
import com.vaadin.flow.function.ValueProvider;

public class VaadinUtils {
    private VaadinUtils() {
    }

    public static <SOURCE> TemplateRenderer<SOURCE> getPlayerRenderer(ValueProvider<SOURCE, Player> playerProvider) {
        String name = StringUtils.getNewRandomString();
        String nickname = StringUtils.getNewRandomString();
        String itemName = StringUtils.getTemplateItemString(name);
        String itemNickname = StringUtils.getTemplateItemString(nickname);
        return TemplateRenderer.<SOURCE>of(StringUtils.getHtmlStringForPlayer(itemName, itemNickname))
                .withProperty(name, (ValueProvider<SOURCE, String>) source -> playerProvider.apply(source).getName())
                .withProperty(nickname, (ValueProvider<SOURCE, String>) source -> playerProvider.apply(source).getNickname());
    }
}
